/**
 * Copyright (c) FOM-Nikhef 2015-
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *
 *  Authors:
 *  2015-
 *     Mischa Sall\'e <msalle@nikhef.nl>
 *     NIKHEF Amsterdam, the Netherlands
 *     <grid-mw-security@nikhef.nl>
 *
 */

#ifndef PARSE_UTILS_H
#define PARSE_UTILS_H


/************************************************************************
 * defines
 ************************************************************************/

#define PSEUDO_VO   "-"	    /* String to match for VOMS-less */

#define RECURSION_MAX	100 /* Maximum level of recursion for info files */


/************************************************************************
 * function prototypes
 ************************************************************************/

/* Reads in the given file into buffer. Buffer needs freeing.
 * return 0 on success, -1 on error */
int _vo_ca_ap_read_file(const char *filename, char **filebuffer);

/* Search for given voname (or PSEUDO_VO when voname==NULL) in buffer. When
 * found, match entries against issuer_dn. For non-absolute `file:'-based
 * entries, the info file is looked for in infodir.
 * \return 1 when match found, 0 when no match found, -1 on error */
int _vo_ca_ap_match_vo_issuer(const char *buffer, const char *infodir,
			      const char *voname, const char *issuer_dn);

#endif
