/**
 * Copyright (c) FOM-Nikhef 2015-
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *
 *  Authors:
 *  2015-
 *     Mischa Sall\'e <msalle@nikhef.nl>
 *     NIKHEF Amsterdam, the Netherlands
 *     <grid-mw-security@nikhef.nl>
 *
 */

#ifndef PLUGIN_UTILS_H
#define PLUGIN_UTILS_H


/************************************************************************
 * defines
 ************************************************************************/

/* Default 'grid-security' dir */
#ifndef SECURITY_DIR
# define SECURITY_DIR	"/etc/grid-security/"	/* default for files/dir */
#endif


/* Define default CA certificate directory */
#ifndef DEFAULT_CERT_DIR
# define DEFAULT_CERT_DIR   SECURITY_DIR"certificates"
#endif


/************************************************************************
 * function prototypes
 ************************************************************************/

/* Get issuer DN from LCMAPS framework
 * \return 0 on succes, -1 on error */
int _vo_ca_ap_get_issuer_dn(int argc, lcmaps_argument_t *argv,
			    char **issuer_dn);

/* Get VO list from from LCMAPS framework, either from list of FQANs or from
 * list of VOMS structures.
 * \return 0 on succes, -1 on error */
int _vo_ca_ap_get_vo_list(int argc, lcmaps_argument_t *argv,
			  char ***vo_list, int *nvos);

/* prefixes relfile with SECURITY_DIR into absfile, which needs freeing
 * \return 0 on success -1 on error */
int _vo_ca_ap_get_prefixed_file(const char *relfile, char **absfile);

#endif
